/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Moz2chΤܡ󎳎Ďގ׎ʡ׎ˤʤ⡣
 * (      )     : 2004/05/11
 *      񤤤  : ؤ41
 * (___)__)   Ď؎ˎގ: 
 *                        abone.jsjslib١˲Τȼäƽ
 *            
 * </pre>
 */

function moz2chAboneView () {

}

moz2chAboneView.prototype = {

    abone: null,

    init: function () {
	try{
	    //줾Τܡĥ꡼
	    var tree = document.getElementById("aboneNameTree");
	    tree.database.AddDataSource(this.abone.ds);
	    tree.builder.rebuild();
	    tree = document.getElementById("aboneMailTree");
	    tree.database.AddDataSource(this.abone.ds);
	    tree.builder.rebuild();
	    tree = document.getElementById("aboneIdTree");
	    tree.database.AddDataSource(this.abone.ds);
	    tree.builder.rebuild();
	    tree = document.getElementById("aboneWordTree");
	    tree.database.AddDataSource(this.abone.ds);
	    tree.builder.rebuild();
	    tree = document.getElementById("aboneLinkTree");
	    tree.database.AddDataSource(this.abone.ds);
	    tree.builder.rebuild();
	}catch(e){
	    opener.moz2ch.debug(e);
	}
    },	
}

/////////////////
// ͎ގġʎݎĎގ׎
var aboneView = new moz2chAboneView();

function moz2chAboneViewLoad() {
    try{	
	aboneView.abone = opener.moz2chAbone;
	aboneView.init();
    }catch(e){
	opener.moz2ch.debug(e);
    }
}

function moz2chAboneViewUnload () {

}

function moz2chAboneOK () {
    try{
	aboneView.abone.update();
	window.close();
    }catch(e){
	alert(e);
    }
}

function moz2chAboneCancel () {
    try{
	aboneView.abone.init();
	window.close();
    }catch(e){
	alert(e);
    }
}

function moz2chAboneAdd() {
    try{
	var text = document.getElementById("aboneText").value;
	
	if ( text.match(/\S+/)) {
	    var tab = document.getElementById("aboneTabBox").selectedTab;
	    var category = tab.id.substring(5,tab.id.length - 3);
	    
	    aboneView.abone.add(category,text);
	    document.getElementById("aboneText").value = "";
	}
    }catch(e){
	opener.moz2ch.debug(e);
    }
	
}

// abone.jsjslibȼäƽɤʤäYO
const kMoz2chNS = "http://moz2ch.sourceforge.jp/index.rdf#";
function moz2chAboneRemove () {

    var tab = document.getElementById("aboneTabBox").selectedTab;
    var category = tab.id.substring(5,tab.id.length - 3);
    var tree = document.getElementById("abone" + category + "Tree");
    var index = tree.currentIndex;
    if ( 0 <= index ) { 
        var seq = aboneView.abone.rdf.getRootSeq("uri:abone:"+ category.toLowerCase());
        var nodes = seq.getSubNodes();
       	aboneView.abone.remove(category, nodes[index].getAttribute(kMoz2chNS + "word"));
    }
}


