 /* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Υ饹ʡ
 * (      )     : 2005/01/14
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: (ߢώ)(ߢώ) tRZ80FPU5k ؤ41
 *           	          : 
 *                      : 
 *            moz2chSure饹ȶʬΥȥȥʡ
 *            
 * </pre>
 */

include("chrome://moz2ch/content/data.js");

function moz2chYahooSure(ita, title, url) {

    this.base = moz2chSure;
    this.base(ita, title, url);

    this.ita = ita;

    var a = this.url.split("/");
    //http:/messages.yahoo.co.jp/bbs?.mm=GN&action=m&board=552018313&tid=bcfeghbft7gbca8hd&sid=552018313&mid=1&type=date&first=1
    this.sabaID = a.splice(2,1).join("/");
    var qs = a.pop().split("&");
    this.board = qs[2].split("=")[1];
    this.tid = qs[3].split("=")[1];
    this.sid = qs[4].split("=")[1];

    this.itaID = ita.itaID;
    this.sureClassName = "moz2chYahooSure";
}

/////////////////////
// extends moz2chData
moz2chYahooSure.prototype = new moz2chSure();

moz2chYahooSure.prototype.bbsId = "yahoo";

/////////////////////////////////
// title/log/download information
moz2chYahooSure.prototype.logPath = null;
moz2chYahooSure.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var logFile = new Dir(this.getBBSDir());
 
        logFile.append(this.itaID);
        if (!logFile.exists())
            logFile.create(kMoz2chDataDirPerm);
        logFile.append(this.tid + ".dat");
        this.logPath = logFile.path;
    }
    return this.logPath;
};

moz2chYahooSure.prototype.getDataURL =
function () {
    //http:/messages.yahoo.co.jp/bbs?.mm=GN&action=m&board=552018313&tid=bcfeghbft7gbca8hd&sid=552018313&mid=1&type=date&first=1
    return this.url;
};

moz2chYahooSure.prototype.get = 
function () {
    var data = "";
    var start = 1;
    var f = new File(this.getLogPath());
    if (f.exists()) {
        f.open("r");
        data = f.read();
        f.close();
        start = data.split("\n").length + 1;
    }

    this.subloader.sure = this;
    this.subloader.currentRes = start;
    this.subloader.count = 0;
    this.subloader.log = "";
    this.subloader.targetURL = this.subloader.getTargetURL(start);
    this.subloader.get();
};


moz2chYahooSure.prototype.subloader = {
    sure : null,  
    targetURL: null,
    currentRes: 0,
    currentStat: 0,
    count: 0,
    log: "",

    ioService: Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService),
    uri: Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI),
    bStream: Components.classes["@mozilla.org/binaryinputstream;1"]
                .createInstance(Components.interfaces.nsIBinaryInputStream),
    get: function () {
        this.data = "";
        // initialize data
		this.uri.spec = this.targetURL;
        if (!this.channel) {
            this.channel = this.ioService.newChannelFromURI(this.uri)
                    .QueryInterface(Components.interfaces.nsIHttpChannel);
            // Monazilla UA
            this.channel.setRequestHeader("User-Agent", moz2ch.ua, false);
            // load bypass cache(strong reload)
            this.channel.loadFlags =
                    Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
        }
        //moz2ch.debug("moz2chData.get: dataURL=" + this.targetURL);
        //moz2ch.debug("moz2chData.get: loadFlags=" + this.channel.loadFlags);
        // arg 3 is invalid? needs to be reconsidered!
        this.channel.asyncOpen(this, this, 0);
    },

    ///////////////////////////////
    // implements nsIStreamListener
    onDataAvailable: function (request, ctxt, input, offset, count) {
        this.bStream.setInputStream(input);
        var str = this.bStream.readBytes(count);
        str = str.replace(/\x00/g, "*");
        this.data += str;
    },

    ////////////////////////////////
    // implements nsIRequestObserver
    onStartRequest: function (request, ctxt) {},
    onStopRequest: function (request, ctxt, status) {
        var resStat;
        try {   // output responseStatus/responseStatusText
            resStat = this.channel.responseStatus;
            //moz2ch.debug(resStat + " " + this.channel.responseStatusText);
        } catch (e) {
            moz2ch.debug(e);
            if (0 != status) {
                // request error! call onError
                moz2ch.debug("requestStatus: " + status);
                this.onError();
                return;
            }
        }
        
        try {
            this.onResponse(resStat);
        } catch (e) {
            moz2ch.debug("moz2chData.onStopRequest: " + e);
        }
    },

    onResponse: function (resStat) {
        try {
            this.currentStat = resStat;
            var data = this;
            function asyncParse() {
                try{
                    var rv = data.parse();

                    if ( rv && data.hasNext()) {
                        data.targetURL = data.getTargetURL(data.currentRes);
moz2ch.debug("get => " + data.currentRes);
                        data.get();
                    } else {
                        data.parseLog();
                        moz2ch.debug("Done");
                    }

                }catch(e){
                    moz2ch.debug("asyncParse Error " + e);
                }
            }
            setTimeout(asyncParse, 0);
        
        } catch (e) {
            moz2ch.debug("moz2chData.onStopRequest: " + e);
        }
    },

    hasNext: function () {
        var rv;
        if ( (this.currentStat != 200) || this.count >= 99) {
            rv = false;
        } else {
            this.currentRes++;
            this.count++;
            rv = true;
        }
        return rv;
    },

    parse: function () {
        var data = this.data;

        var blocks = data.split("<table");

        var rv;
        var regTitle = new RegExp("<td valign=\"top\"><big><b>(.*)</b></big><small>");
        var regDate = new RegExp("<td valign=top align=right><small>(.*)<br>");
        var regProf = new RegExp("<a href=\"http://rd.yahoo.co.jp/messageboards/prof/.*>(.*)</a>");
        var regMsg = new RegExp("<p>\n((.|\n|\r)*)\n</td></tr></table>");
        var regRes = new RegExp("<td valign=middle colspan=2><small>.*<a href=\".*\">(.*)</a>");
        var title, date, prof, msg, res = 0;

        for(var i=0; i<blocks.length; i++) {
            rv = regTitle.exec( blocks[i] );
            if ( rv )
                title = rv[1];
            rv = regDate.exec( blocks[i] );
            if ( rv )
                date = rv[1];
            rv = regProf.exec( blocks[i] );
            if ( rv )
                prof = rv[1];
            rv = regMsg.exec( blocks[i] );
            if ( rv )
                msg = rv[1];
            rv = regRes.exec( blocks[i] );
            if ( rv ) {
                res = rv[1];
            }
        }
        if ( msg ) { 
            //moz2ch.debug(title + " " + date + " " + prof + " " + msg + " " + res);
            this.log += this.currentRes + "\t" + res + "\t" + date 
                     + "\t" + prof + "\t" + title + "\t" + msg + "\n";
           return true;
        } else {
            return false;
        }
    },

    parseLog: function () {
        //moz2ch.debug(this.sure.data);
        if ( ! this.sure.data ) this.sure.data = "";
        this.sure.data += this.log
        var f = new File(this.sure.getLogPath());
        f.open("w", kMoz2chDataFilePerm);
        f.write(this.sure.data);
        f.close();

        this.sure.parse();
    },

    getTargetURL: function ( idx ) {
        return "http://" + this.sure.sabaID + "/bbs?.mm=GN&action=m&board=" + this.sure.board + "&tid=" + this.sure.tid 
               + "&sid=" + this.sure.sid + "&mid=" + idx + "&type=date&first=1";
    },

};

/////////////////
// parse the data

moz2chSure.prototype.dataConvert =
function () {
    var data = moz2chCharset.euc2uni(this.data);

    // NULLʎގкޤʤन
    // data = data.replace(/\0/g, "*");
    // $üʸƤޤΤǡ餫$$Ѵ
    data = data.replace(/\$/g, "$$$$");
    data = data.replace(/&amp([^;])/gi, "&$1");

	return data;
};

moz2chSure.prototype.makeSabun =
function () {
    var sabun = moz2chCharset.euc2uni(this.sabun);
    sabun = sabun.replace(/\$/g, "$$$$");
    sabun = sabun.replace(/&amp([^;])/gi, "&$1");

	return sabun;
};

moz2chYahooSure.prototype.mainParse =
function (lines. sabun_lines) {
try{
    const delimiter = "\t";

    var html = new Array(lines.length + 1);
    html[0] = this.htmlHeader.replace(/<MOZ2CHFONT\/>/g, fontFamily);

    var ary = lines[0].split(delimiter);
    if (ary.length < 2)
        return false;
    html[0] = html[0].replace(/<THREADNAME\/>/g, this.title);
    if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
	html[0] += this.parseRes(1, ary[3], ary[1], ary[2], ary.slice(5), ary[1], ary[4]);
	}

    //뤰
    //if (!moz2ch.sureCount) moz2ch.resetSureCount();
    var start = ( lines.length - moz2ch.sureCount - 1 > 1)? lines.length - moz2ch.sureCount - 1 : 1;
    for (var i = start; i < lines.length; i++) {
        var ary = lines[i].split(delimiter);
        if (ary.length < 2)
            break;
        if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
            html[i] = this.parseRes(i + 1, ary[3], ary[1], ary[2], ary.slice(5), ary[1], ary[4]);
        }
    }
    html = html.join(" ");
    html += this.htmlFooter;
    html = html.replace(reg_getres, "").replace(reg_allres, "")
               .replace(reg_newres, "").replace(reg_sureurl, "");

	return html;
};

moz2chSure.prototype.setSureAcq =
function (l, sl) {
    //Ѥߤͤ򎾎Î
    this.ita.setAttribute(this.sureId, "sureAcq", l - 1);
    if(this.sabun){
	this.ita.setAttribute(this.datID + ".dat", "sureNew", sl - 1);
	this.sabun = null;
    }
};

moz2chYahooSure.prototype.parseRes = 
function (num, name, mail, date, msg, res, subject) { 
    var mailname = (mail) ? '<a href="mailto:' + name + '"><b>' + name + '</b></a>' : '<b class=\"mailname\">' + name + '</b>';
    if ( 0 < res )  msg = "<a href=\"#" + res + "\">&gt;&gt;" + res + "</a><br/>" + msg;
    msg = "<b>" + subject + "</b><br/></br>" + msg;
    var nameonly = '<span style="color:green"><b>' + name + '</b></span>';

    return this.htmlRes.replace( reg_num, '<a name="' + num + '"></a>' + num)
                       .replace( reg_plainnum, num)
                       .replace( reg_mailname, mailname)
                       .replace( reg_name, nameonly)
                       .replace( reg_mail, mail)
                       .replace( reg_date, date)
                       .replace( reg_msg, msg)
                       .replace(reg_resnolink_old, '<a href="#$1">')
                       .replace(reg_resnolink_new, '<a href="#$1">')
                       .replace(reg_http_link, '$1<a href="http$3:$4" target="_blank">$2$3:$4</a>')
                       .replace(reg_ftp_link, '<a href="ftp:$1" target="_blank">ftp:$1</a>'); 
};

