/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   BBSManager饹ʡ itaTree,ita,sureκԤ
 * (      )     : 2004/05/17
 *      񤤤  : ؤ41
 * (___)__)   ȥӥݥ: 
 *                        
 *            
 *
 * </pre>
 */

//BBSڤդäʥ饹ϤǥݥɤʡŪˤloadSubscriptȤYO!
//2ch
include("chrome://moz2ch/content/bbs/2ch/itaTree.js");
include("chrome://moz2ch/content/bbs/2ch/ita.js");
include("chrome://moz2ch/content/bbs/2ch/sure.js");
include("chrome://moz2ch/content/bbs/2ch/kakiko.js");
//yahoo
include("chrome://moz2ch/content/bbs/yahoo/itaTree.js");
include("chrome://moz2ch/content/bbs/yahoo/ita.js");
include("chrome://moz2ch/content/bbs/yahoo/sure.js");
include("chrome://moz2ch/content/bbs/yahoo/kakiko.js");
//machi
include("chrome://moz2ch/content/bbs/machi/itaTree.js");
include("chrome://moz2ch/content/bbs/machi/ita.js");
include("chrome://moz2ch/content/bbs/machi/sure.js");
include("chrome://moz2ch/content/bbs/machi/kakiko.js");
//jbbs
include("chrome://moz2ch/content/bbs/jbbs/itaTree.js");
include("chrome://moz2ch/content/bbs/jbbs/ita.js");
include("chrome://moz2ch/content/bbs/jbbs/sure.js");
include("chrome://moz2ch/content/bbs/jbbs/kakiko.js");

function moz2chBBSManager() {
}

moz2chBBSManager.prototype = {

   
    createItaTree: function( bbsId, title, url ) {
	try{
        switch( bbsId ) {
        case "yahoo":
            return new moz2chYahooItaTree( title, url );
        case "machi":
            return new moz2chMachiItaTree( title, url );
	case "jbbs":
	    return new moz2chJbbsItaTree( title, url );
        case "2ch":
        default:
            return new moz2ch2chItaTree( title, url );
        }
	}catch(e){ moz2ch.debug(e); }
    },

    createIta: function( bbsId, itaTree, title, url ) {
	try{
        switch( bbsId ) {
        case "yahoo":
            return new moz2chYahooIta( itaTree, title, url );
        case "machi":
            return new moz2chMachiIta( itaTree, title, url );
	case "jbbs":
            return new moz2chJbbsIta( itaTree, title, url );
        case "2ch":
        default:
            return new moz2ch2chIta( itaTree, title, url );
        }
	}catch(e){ moz2ch.debug(e); }
    },

    createSure: function( bbsId, ita, title, url ) {
	try{
        switch( bbsId ) {
        case "yahoo":
            return new moz2chYahooSure( ita, title, url );
        case "machi":
            return new moz2chMachiSure( ita, title, url );
        case "jbbs":
            return new moz2chJbbsSure( ita, title, url );
        case "2ch":
        default:
            return new moz2ch2chSure( ita, title, url );
        }
	}catch(e){ moz2ch.debug(e); }
    },

	createKakiko: function( bbsId ) {
		switch( bbsId ) {
		case "2ch":
		    return new moz2ch2chKakiko();
		case "jbbs":
		    return new moz2chJbbsKakiko();
		default:
		    return null;
		}
	}
}
