/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   Υ饹ʡ
 * (      )     : 2005/01/14
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: (ߢώ)(ߢώ) tRZ80FPU5k
 *                        ؤ41
 *                        
 *            ۤȤɤΥ쥯饹ζѿ򤳤褦ˤʡ
 *            
 * </pre>
 */

//Regular Expression ʎߎ (®Τ)
var reg_resnolink_old = new RegExp().compile("<a href=\"\.\.\/test\/read\.cgi\\?bbs=[a-zA-Z0-9]+\&amp;key=[0-9]+\&amp;st=([0-9]{1,4})\&amp;to=[0-9]{1,4}(\&amp;nofirst=true)?\" target=\"_blank\">","g");
var reg_resnolink_new = new RegExp().compile("<a href=\"\.\.\/test\/read\.cgi\/[a-zA-Z0-9]+\/[0-9]+\/([0-9]{1,4})(-[0-9]{1,4})?\" target=\"_blank\">","g");
var reg_normal_link = new RegExp().compile("([^f])(http|ttp|tp)\:(\/\/[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+)","g");
var reg_normal_sshlink = new RegExp().compile("([^f])(http|ttp|tp)s\:(\/\/[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+)","g");
var reg_ftp_link = new RegExp().compile("ftp\:(\/\/[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+)","g");
var reg_http_abone_link = new RegExp().compile("([^f])(http|ttp|tp)d\:(\/\/[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+)","g");
var reg_ftp_abone_link = new RegExp().compile("ftpd\:(\/\/[-_.!~*'a-zA-Z0-9;/?:@&=+$,%#]+)","g");
var reg_resnotolink = new RegExp().compile('([^"]>|[^<;]|[^>]&gt;)&gt;([0-9]{1,4})',"g");
var reg_id_abone_link = new RegExp().compile("ID\:([a-zA-Z0-9/+.]{8,9})","g")

var reg_num = new RegExp().compile("<NUMBER\/>", "g")
var reg_plainnum = new RegExp().compile("<PLAINNUMBER\/>", "g");
var reg_mailname = new RegExp().compile("<MAILNAME\/>", "g");
var reg_name = new RegExp().compile("<NAME\/>", "g");
var reg_mail = new RegExp().compile("<MAIL\/>", "g");
var reg_date = new RegExp().compile("<DATE\/>", "g");
var reg_msg  = new RegExp().compile("<MESSAGE\/>", "g");
var reg_getres = new RegExp().compile("<GETRESCOUNT/>", "g");
var reg_newres = new RegExp().compile("<NEWRESCOUNT/>", "g");
var reg_allres = new RegExp().compile("<ALLRESCOUNT/>", "g");
var reg_sureurl = new RegExp().compile("<THREADURL/>", "g");

function moz2chSure(ita, title, url) {
    this.base = moz2chData;
    this.base(title, url);
   
    this.ita = ita;
	this.getSkin();
}

/////////////////////
// extends moz2chData
moz2chSure.prototype = new moz2chData();

moz2chSure.prototype.sureId = "";
moz2chSure.prototype.sabun = null;
moz2chSure.prototype.old_html = null;
moz2chSure.prototype.old_URL = null;
moz2chSure.prototype.sureClassName = "moz2chSure";
moz2chSure.prototype.kakikoView = null;
moz2chSure.prototype.aboneRes = new Array();
moz2chSure.prototype.htmlHeader = "";
moz2chSure.prototype.htmlRes = "";
moz2chSure.prototype.htmlNewRes = "";
moz2chSure.prototype.htmlFooter = "";
moz2chSure.prototype.logPath = null;

/////////////////////////////////
// title/log/download information

moz2chSure.prototype.__defineGetter__("sureId",
function () {
    return this.datID + ".dat";
});

moz2chSure.prototype.getTitle =
function () {
    return this.title + moz2ch.separator + this.ita.getTitle();
};

moz2chSure.prototype.getLogPath =
function () {
    if (!this.logPath) {
        var logFile = new Dir(this.getBBSDir());
        var sabaIDs = this.sabaID.split("/");
        for (var i = 0; i < sabaIDs.length; i++) {
            logFile.append(sabaIDs[i]);
            if (!logFile.exists())
                logFile.create(kMoz2chDataDirPerm);
        }
        logFile.append(this.itaID);
        if (!logFile.exists())
            logFile.create(kMoz2chDataDirPerm);
        logFile.append(this.datID + ".dat");
        this.logPath = logFile.path;
    }
    return this.logPath;
};

moz2chSure.prototype.getDataURL =
function () {
    return "http://" + this.sabaID + "/" + this.itaID + "/dat/" + this.datID + ".dat";
};

moz2chSure.prototype.loadLocalDat =
function ( fileURL ) {
    try{
        var f = new File(fileURL);
		if (!f.exists())
            return false;
        this.loading();
        f.open("r");
        this.data = f.read();
        f.close();
	var temp = this.data.split("\n");
	if(temp.pop() != ""){
	    this.data = this.data + "\n";
	}
        this.parse();
        this.loaded();
    }catch(e){ 
	moz2ch.debug(e);
    }
};

moz2chSure.prototype.getSkin =
function() {
	this.htmlHeader = moz2chskin.getHeader(moz2ch.skinName);
	this.htmlFooter = moz2chskin.getFooter(moz2ch.skinName);
	this.htmlRes    = moz2chskin.getRes(moz2ch.skinName);
	this.htmlNewres = moz2chskin.getNewres(moz2ch.skinName);
};

/////////////////
// parse the data

moz2chSure.prototype.DataConvert =
function () {
    var data = moz2chCharset.sjis2uni(this.data);

    // NULLʎގкޤʤन
    // data = data.replace(/\0/g, "*");
    // $üʸƤޤΤǡ餫$$Ѵ
    data = data.replace(/\$/g, "$$$$");
    data = data.replace(/&amp([^;])/gi, "&$1");

	return data;
}

moz2chSure.prototype.makeSabun =
function () {
    var sabun = moz2chCharset.sjis2uni(this.sabun);
    sabun = sabun.replace(/\$/g, "$$$$");
    sabun = sabun.replace(/&amp([^;])/gi, "&$1");

	return sabun;
};

moz2chSure.prototype.parse =
function () {
    try{
    var timer = new Date();
    var start_t = timer.getTime();

	var data = this.dataConvert();

	var sabun = this.sabun?this.makeSabun():null;

	var lines = new Array();	
	lines = data.split("\n");

    var sabun_lines = new Array();
    sabun_lines = sabun?sabun.split("\n"):"";
	
	if (lines.length == 0) {
	    moz2ch.debug(this.sureClassName + ".parse: Parse Error, Do not save the data!");
	    return false;
	}
	
	html = this.mainParse(lines, sabun_lines);
	
	var url;
	var n;
	var tab_node = moz2ch.sureView.element.mTabContainer.childNodes;
	for(i = 0; i< tab_node.length; i++){
		if(!tab_node[i].sure) continue;
		if(tab_node[i].sure.getLogPath() == this.getLogPath())
				n = i;
	}
	if (html.length > 0) {
		fname = "moz2ch_" + n + ".html";
        var f = new File(this.getMoz2chDir());
		f.append(fname);
	    f.open("w", kMoz2chDataFilePerm);
	    f.write(moz2chCharset.uni2sjis(html));
	    f.close();
	    
	    //2byteʸJSLibΥХ
	    var localFile = Components.classes['@mozilla.org/file/local;1']
		           .createInstance(Components.interfaces.nsILocalFile);
	    
	    localFile.initWithPath(f.path);
	    var ioService = Components.classes['@mozilla.org/network/io-service;1']
		             .getService(Components.interfaces.nsIIOService);
	    url = ioService.newFileURI(localFile).spec;
	    localFile = null;
	    ioService = null;
	} else {
	    url = "about:blank";
	}

	this.setSureAcq(lines.length, sabun_lines.length);
	
	//٥ȥ֥ȡꥹʡѤ롣
	var load_data = this;
	var eo = {
	    url: url,
		data: load_data,
	};
	
	//٥ȥꥹʡFireۥȤloaded()ǸƤӤ
	for( i=0; i < this.dataLoadedListener.length; i++ ) {
	    this.dataLoadedListener[i].onDataLoaded( eo );
	}
	
	// Parse succeeded
	var timer2 = new Date();
	var end_t = timer2.getTime();
	moz2ch.debug("time:" + (end_t - start_t) + "msec.");
	return true;
    }catch(e){ moz2ch.debug(e); }
};

moz2chSure.prototype.mainParse = 
function (lines, sabun_lines) {
	var delimiter = "<>";
	var abone_array = moz2chAbone.linkAboneArray.length;

	if((this.old_URL != this.getDataURL()) || !this.old_html || !this.sabun){
	    this.old_URL = this.getDataURL();
	    
	    html = new Array(lines.length - 1);
	    this.old_html = new Array(lines.length - 1);
	    this.aboneRes = new Array(lines.length - 1);
	    html[0] = this.htmlHeader;
	    
	    //1쥹ܤSUBJECTäƤΤ̤˽
	    var ary = lines[0].split(delimiter);
	    if (ary.length < 2){
		delimiter=",";
		ary=ary[0].split(delimiter);
	    }
	    if (ary.length < 2) return false;
	    html[0] = html[0].replace(/<THREADNAME\/>/g, ary[4]);
	    if(this.title == moz2ch.getString("untitled"))
		this.title = ary[4];

		this.old_html[0] = this.parseRes(1, ary[0], ary[1], ary[2], ary[3]);

	    if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
			this.aboneRes[0] = 0;
			html[0] += this.old_html[0];
	    }else{
			this.aboneRes[0] = 1;
		}

	    if(this.sureAcq == 0){
			this.old_html[0] = this.old_html[0].replace('<b class="new">New!</b>', "");
	    }

	    //2쥹ܰʹߤƱʤΤǤ뤰
	    var start = ( lines.length - moz2ch.sureCount > 1)? lines.length - moz2ch.sureCount : 1;
	    for (var i = start; i < (lines.length - 1); i++) {
			var ary = lines[i].split(delimiter);
			if (ary.length < 2){
		    	delimiter=",";
		    	ary=ary[0].split(delimiter);
			}
			if (ary.length < 2) break;
	    	this.old_html[i] = this.parseRes(i + 1, ary[0], ary[1], ary[2], ary[3]);
			if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
		    	if(abone_array != 0)
				ary[3] = moz2chAbone.linkCheck(ary[3]);
				html[i] = this.old_html[i];
				this.aboneRes[i] = 0;
			}else{
		    	html[i] = "";
				this.aboneRes[i] = 1;
			}
			this.old_html[i] = this.old_html[i].replace('<b class="new">New!</b>', "");
	    }
	}else{
	    html = new Array(lines.length - 1);
		var old_aboneRes = this.aboneRes;
		this.aboneRes = new Array(lines.length - 1);
	    html[0] = this.htmlHeader;//.replace(/<MOZ2CHFONT\/>/g, fontFamily);
	    html[0] = html[0].replace(/<THREADNAME\/>/g, this.title);

	    html[0] += this.old_html[0];

	    var start = ( lines.length - moz2ch.sureCount > 1)? lines.length - moz2ch.sureCount : 1;
	    for (var i = start; i < (lines.length-sabun_lines.length); i++) {
			if(old_aboneRes[i] == 0){
				html[i] = this.old_html[i];
				this.aboneRes = 0
			}else{
				html[i] = "";
				this.aboneRes = 1
			}
	    }
	    
	    for (var i = (lines.length-sabun_lines.length); i < (lines.length - 1); i++){
			var ary = lines[i].split(delimiter);
			if (ary.length < 2){
		    	delimiter=",";
		    	ary=ary[0].split(delimiter);
			}
			if (ary.length < 2) break;
	    	this.old_html[i] = this.parseRes(i + 1, ary[0], ary[1], ary[2], ary[3]);

			if (! moz2chAbone.shouldAbone(ary[0], ary[1], ary[2], ary[3])){ // name, mail, id, msg
		    	if(abone_array != 0)
					ary[3] = moz2chAbone.linkCheck(ary[3]);
		    	html[i] = this.old_html[i];
				this.aboneRes[i] = 0;
			}else{
		    	html[i] = "";
				this.aboneRes[i] = 1;
			}
			this.old_html[i] = this.old_html[i].replace('<b class="new">New!</b>', "");
	    }
	}
	
	html = html.join(" ");
	html += this.htmlFooter;
	html = html.replace(reg_getres, this.ita.getAttribute(this.datID + ".dat", "sureAcq"))
	           .replace(reg_newres, lines.length - 1 - this.ita.getAttribute(this.datID + ".dat", "sureAcq"))
	           .replace(reg_allres, lines.length - 1)
	           .replace(reg_sureurl, this.url.replace(/\/l50/g, ".dat"));

	return html;
};

moz2chSure.prototype.parseRes = 
function (num, name, mail, date, msg) { 
    var mailname;
    if(mail.match("http://")){
	mailname = '<span style="color:green"><a href="' + mail + '"><b>' + name + '</b></a></span>';
    }else{
	mailname = (mail) ? '<span style="color:green"><a href="mailto:' + mail + '"><b>' + name + '</b></a></span>' : '<span style="color:green"><b>' + name + '</b></span>';
    }
    var nameonly = '<span style="color:green"><b>' + name + '</b></span>';
    if ( num > this.sureAcq )
        var htmlRes = this.htmlNewres;
    else
        var htmlRes = this.htmlRes;
    return htmlRes.replace( reg_num, '<a name="' + num + '"></a><a href="#kakiko' + num + '">' + num + '</a>')
                       .replace(reg_msg, msg)
                       .replace(reg_resnolink_old, '<a href="#$1">')
                       .replace(reg_resnolink_new, '<a href="#$1">')
                       .replace(reg_resnotolink, '$1<a href="#$2">&gt;$2</a>')
                       .replace(reg_normal_link, '$1<a href="http\:$3" target="_blank">$2\:$3</a>')
                       .replace(reg_normal_sshlink, '$1<a href="https\:$3" target="_blank">$2s\:$3</a>')
                       .replace(reg_ftp_link, '<a href="ftp:$1" target="_blank">ftp:$1</a>')
                       .replace(reg_http_abone_link, "$1$2:$3")
                       .replace(reg_ftp_abone_link, "ftp:$1")
                       .replace( reg_plainnum, num)
                       .replace( reg_mailname, mailname)
                       .replace( reg_name, nameonly)
                       .replace( reg_mail, mail)
                       .replace( reg_date, date)
					   .replace( reg_id_abone_link, 'ID:<a href="#idabone_$1">$1</a>');
};

moz2chSure.prototype.checkEntity =
function (data) {
	// ä롼Ǥ
	// ǽ&&amp;Ѵ
	data = data.replace(/&/g, "&amp;");
	//HTMLλȤõơ᤹
	data = data.replace(/&amp;\s*a(cute|nd|ng|uml);/g, "&a$1;");
	data = data.replace(/&amp;\s*b(dquo|eta|rvbar|ull);/g, "&b$1;");
	data = data.replace(/&amp;\s*c(ap|edil|ent|lubs|opy|up|urren);/g, "&c$1;");
	data = data.replace(/&amp;\s*d(arr|eg|iams);/g, "&d$1;");
	data = data.replace(/&amp;\s*e(msp|nsp|psilon|quiv|ta|uro);/g, "&e$1;");
	data = data.replace(/&amp;\s*f(orall|rac12|rac14|rac34);/g, "&f$1;");
	data = data.replace(/&amp;\s*g(amma|t);/g, "&g$1;");
	data = data.replace(/&amp;\s*h(earts|ellip);/g, "&h$1;");
	data = data.replace(/&amp;\s*i(excl|ota|quest|sin);/g, "&i$1;");
	data = data.replace(/&amp;\s*L(ambda);/g, "&L$1;");
	data = data.replace(/&amp;\s*l(aquo|arr|dquo|owast|rm|ro|saquo|squo|t);/g, "&l$1;");
	data = data.replace(/&amp;\s*m(acr|dash|icro|iddot);/g, "&m$1;");
	data = data.replace(/&amp;\s*n(bsp|i|ot);/g, "&n$1;");
	data = data.replace(/&amp;\s*o(mega|r|rdf|rdm);/g, "&o$1;");
	data = data.replace(/&amp;\s*P(i|rime);/g, "&P$1;");
	data = data.replace(/&amp;\s*p(ara|ound|i|lrime|rime|usmn);/g, "&p$1;");
	data = data.replace(/&amp;\s*q(uot);/g, "&q$1;");
	data = data.replace(/&amp;\s*r(adic|an|aquo|arr|as|dquo|eg|f|lm|lo|usi|saquo|squo);/g, "&r$1;");
	data = data.replace(/&amp;\s*s(bquo|hy|pades|ect|up2|up3|up1|up|ub);/g, "&s$1;");
	data = data.replace(/&amp;\s*S(igma);/g, "&s$1;");
	data = data.replace(/&amp;\s*t(au|here4|hinsp|rade|imes);/g, "&t$1;");
	data = data.replace(/&amp;\s*u(arr|ml|psilon);/g, "&u$1;");
	data = data.replace(/&amp;\s*X(i);/g, "&X$1;");
	data = data.replace(/&amp;\s*y(en);/g, "&y$1;");
	data = data.replace(/&amp;\s*#([0-9]{1,5}|x[0-9a-zA-Z]{4});/g, "&#$1;");
	//ǽ餫&amp;amp;äΤ򸵤᤹
	data = data.replace(/&amp;\s*(amp);/g, "&$1;");

	return data;
};

moz2chSure.prototype.setSureAcq =
function (l, sl) {
	//Ѥߤͤ򥻥ơݥ
	this.ita.setAttribute(this.datID + ".dat", "sureAcq", l - 1);
	this.sureAcq = l - 1;
	if(this.sabun){
	    this.ita.setAttribute(this.datID + ".dat", "sureNew", sl - 1);
	    this.sabun = null;
	}
};

/////////////////////
// code for SABUN get

moz2chSure.prototype.onRequest =
function () {
	try{
    // SABUN get code
    // set "Range" and "If-Modified-Since" request header for SABUN get
    var f = new File(this.getLogPath());

    if (f.exists() && this.ita.getAttribute(this.datID + ".dat", "lastModified")) {
        this.channel.setRequestHeader("If-Modified-Since",
                this.ita.getAttribute(this.datID + ".dat", "lastModified"), false);
        this.channel.setRequestHeader("Accept-Encoding", "identity", false); 
        moz2ch.debug(this.sureClassName + ".onRequest: lastModified="
                + this.ita.getAttribute(this.datID + ".dat", "lastModified"));
        this.channel.setRequestHeader("Range", "bytes=" + f.size + "-", false);
    }
	}catch(e){ moz2ch.debug(e); }
};

moz2chSure.prototype.onResponse =
function (resStat) {
    if(this.ita.getAttribute(this.datID + ".dat", "sureAttr") != "NON-DAT" && this.ita.getAttribute(this.datID + ".dat", "sureAttr") != "LOG-DAT"){
	this.ita.setAttribute(this.datID + ".dat", "sureAttr", "LOADED");
    }
    moz2ch.status(moz2ch.getString("checkdata"));
    switch (resStat) {
    case 200: // Ok
		var res = this.res200();
		if(res == 1) return;
        break;
    case 206: // Partial Content
		this.res206();
        break;
    case 304: // Not Modified
		this.res304();
		this.oldData = "";
        return;
    case 416:
		this.res416();
		return;
    default:
		this.data = this.oldData;
		this.oldData ="";
        moz2ch.status();
		moz2ch.defaultStatus(moz2ch.getString("onerror"));
        this.onError();
        return;
    }

	try{
	this.saveLastModified();
	}catch(e){ moz2ch.debug(e); }
    this.onGet();
};

moz2chSure.prototype.res200 =
function () {
	var data = moz2chCharset.sjis2uni(this.data);
	data = data.replace(/\$/g, "$$$$");
	data = data.replace(/&amp([^;])/gi, "&$1");

	data = data.split("\n");
	if(data.length <= 1) { 
		this.data = this.oldData;
		this.oldData = "";
		return 1;
	}

	this.oldData = "";
	this.ita.setAttribute(this.datID + ".dat", "sureNew", data.length - 1);
	return 0;
};

moz2chSure.prototype.res206 =
function () {
	moz2ch.status(moz2ch.getString("sabunget"));
	this.sabun = this.data;
    this.data = this.oldData + this.data;
	this.oldData = "";
};

moz2chSure.prototype.res304 =
function () {
	this.data = this.oldData;
	this.oldData ="";
	if(!this.ita.getAttribute(this.datID + ".dat", "sureNew"))
	    this.ita.setAttribute(this.datID + ".dat", "sureNew", 0);
	if(this.ita == moz2ch.itaView.data)
	    moz2ch.itaView.element.mCurrentTree.treeBoxObject.invalidate();
        moz2ch.status();	
	moz2ch.defaultStatus(moz2ch.getString("nonchange"));
};

moz2chSure.prototype.res416 =
function () {
	this.oldData ="";
	moz2ch.status("now regetting sure dat...");
	moz2ch.sureView.logDelete();
	moz2ch.sureView.reGet();
};

moz2chSure.prototype.saveLastModified =
function () {
    // save Last-Modified string from the server
    try {
        this.lastModified = this.channel.getResponseHeader("Last-Modified");
        moz2ch.debug(this.sureClassName + ".onResponse: Last-Modified: " + this.lastModified);
	this.lastAccess = new Date(Date.parse(this.channel.getResponseHeader("Date"))); //Date֥ȤǻYO
        this.ita.setAttribute(this.datID + ".dat", "lastModified", this.lastModified);
    } catch (e) {
        moz2ch.debug(this.sureClassName + ".onResponse: " + e);
    }
};

moz2chSure.prototype.getRes = 
function( target ){
    var res;
    const delimiter = "<>";
    if(this.old_html[target]){
		if(!moz2ch.popupAbone && this.aboneRes[target] == 1){
			return "";
		}
		return this.old_html[target];
    }
    return "";
};

moz2chSure.prototype.clearSureAttribute =
function(){
    this.ita.setAttribute(this.datID + ".dat", "lastModified", "");
    this.ita.setAttribute(this.datID + ".dat", "sureAttr", "NONDIS");
    this.ita.setAttribute(this.datID + ".dat", "surePos", 0);
    this.ita.setAttribute(this.datID + ".dat", "sureAcq", 0);
    this.ita.setAttribute(this.datID + ".dat", "sureNew", null);
    this.sureAcq = 0;
    if(this.ita.url == moz2ch.itaView.data.url){
	moz2ch.itaView.reload();
    }else{
		this.ita.writeIndex();
	}
};

moz2chSure.prototype.destroy =
function(){
	delete this.ita;
	delete this.old_html;
	delete this.old_URL;
	delete this.lastModified;
	delete this.sureAcq;
	delete this.sabun;
	delete this.sureClassName;
	delete this.kakikoView;
	delete this.aboneRes;
	delete this.htmlHeader;
	delete this.htmlRes;
	delete this.htmlNewRes;
	delete this.htmlFooter;
	delete this.logPath;
	delete this.sabaID;
	delete this.itaID;
	delete this.datID;
	delete this.title;
};
