/* -*- coding: euc-jp-unix -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Moz2ch.
 *
 * The Initial Developer of the Original Code is Moz2ch Project.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**
 * <pre lang="ja">
 * (_(    
 * ( `)   ӥ塼饹ʡ
 * (      )     : 2005/01/27
 *      񤤤  : ˼⤸顼
 * (___)__)   Ď؎ˎގ: ĶAnne
 *                      : ؤ41
 *                      : (ߢώ)(ߢώ) tRZ80FPU5k
 *                      : 
 *                      : 
 *            FindBar!
 *            
 * </pre>
 */

include("chrome://global/content/contentAreaUtils.js");

const winm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

function moz2chSureView () {
};

moz2chSureView.prototype = new moz2chDataView();

//Хѿ
var data_name = null;
var data_date = null;

var img_timer = null;
var pop_timer = null;
var mail_timer = null;
var disp_timer = null;
var pos_timer = null;

var maxid = 0;
var popupId = new Array();

//sureView饹ѿ
moz2chSureView.prototype.tagetBrowser = null;

moz2chSureView.prototype.load_flag = 0;

moz2chSureView.prototype.presentPopup = 0;
moz2chSureView.prototype.popupColor = null;
moz2chSureView.prototype.canImgPopup = null;
moz2chSureView.prototype.tabLink = null;

moz2chSureView.prototype.onmouseNode = null;
moz2chSureView.prototype.onmouseTargetId = null;

moz2chSureView.prototype.elementId = "content";

//sureǡsetter,getter
moz2chSureView.prototype.__defineGetter__("data",
function () {
    if ( this.element.selectedTab.sure )
        return this.element.selectedTab.sure;
});

moz2chSureView.prototype.__defineSetter__("data",
function( data ) {
    this.element.selectedTab.sure = data;
});

//
moz2chSureView.prototype.baseInit = moz2chDataView.prototype.init;
moz2chSureView.prototype.init =
function () {
    this.baseInit();

    this.element.addProgressListener(this);   //webProgressListenerɲ
    //this.element.addEventListener("keypress", moz2ch.onBrowserKeyPress, false);
    this.loadURI("chrome://moz2ch/content/neta/index.xhtml");

    if(nsPreferences.getLocalizedUnicharPref("moz2ch.popupColor")){
	this.popupColor = "#" + nsPreferences.getLocalizedUnicharPref("moz2ch.popupColor");
    }else{ 
	this.popupColor = "#DDECFF";
	nsPreferences.setUnicharPref("moz2ch.popupColor", "DDECFF");
    }
    if(nsPreferences.getBoolPref("moz2ch.enableImgPopup") != null){
	this.canImgPopup = nsPreferences.getBoolPref("moz2ch.enableImgPopup");
    }else{
	this.canImgPopup = "true";
	nsPreferences.setBoolPref("moz2ch.enableImgPopup", true);
    }
    if(nsPreferences.getBoolPref("moz2ch.sureNormalLinkwithTab") != null){
	this.tabLink = nsPreferences.getBoolPref("moz2ch.sureNormalLinkwithTab");
    }else{
	this.tabLink = "true";
	nsPreferences.setBoolPref("moz2ch.sureNormalLinkwithTab", true);
    }
    data_name = moz2ch.getString("sureName");
    data_date = moz2ch.getString("sureDate");
};

//Loadطδؿ
moz2chSureView.prototype.getContentURL =
function () {
    return this.element.contentDocument.location;
};

moz2chSureView.prototype.baseLoad = moz2chDataView.prototype.load;
moz2chSureView.prototype.load =
function ( data ) {
    this.targetBrowser = this.element.mCurrentBrowser;
    this.baseLoad( data );
};

moz2chSureView.prototype.baseReload = moz2chDataView.prototype.reload;
moz2chSureView.prototype.reload =
function ( data ) {
    this.targetBrowser = this.element.mCurrentBrowser;
    this.baseReload( data );
};

moz2chSureView.prototype.reloadTab =
function(tab) {
    try{
    if(tab == this.element.selectedTab){
	this.load_flag = 0;
	this.removePopup();
        moz2ch.itaView.saveCurSurePos();
	this.reload(this.data);
    }else{
	tab.sure.reload();
    }
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.reloadTabAll =
function(tab) {
    try{
    if(tab == this.element.selectedTab){
		this.load_flag = 0;
		this.removePopup();
        moz2ch.itaView.saveCurSurePos();
	    var f = new File(this.data.getLogPath());
	    if (f.exists()) {
	        f.open("r");
    	    this.data.data = f.read();
        	f.close();
			var temp = this.data.data.split("\n");
			if(temp.pop() != ""){
	    		this.data.data = this.data.data + "\n";
			}
		}
		this.data.old_html = null;
		this.data.parse()
    }else{
	    var f = new File(tab.sure.getLogPath());
	    if (f.exists()) {
	        f.open("r");
    	    tab.sure.data = f.read();
        	f.close();
			var temp = tab.sure.data.split("\n");
			if(temp.pop() != ""){
	    		tab.sure.data = tab.sure.data + "\n";
			}
		}
		tab.sure.old_html = null;
		tab.sure.parse();
    }
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.reloadAllTabs =
function() {
    try{
	var tab_node = this.element.mTabContainer.childNodes;
	for(var i=0; i<tab_node.length; i++){
		if(tab_node[i].sure){
	    	this.reloadTab(tab_node[i]);
		}else
	    	this.element.getBrowserForTab(tab_node[i]).reload();
	}
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.reGet =
function(){
    try{
    if(this.data){
	var url = this.data.url;
	var bbsId = this.data.bbsId;
	var ita = this.data.ita;
	var title = this.data.title;
	var sure = moz2ch.bbsManager.createSure(bbsId, ita, title, url);
	sure.addDataLoadedListener( this );
	this.data.old_URL = null;
	this.data.old_html = null;
	this.load(sure);
	this.reload();
    }
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.loadURI =
function (uri) {
    try {
	if ( this.targetBrowser ) {
	    this.targetBrowser.loadURIWithFlags(uri,
			Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
			null, null, null );
	} else {
	    this.element.webNavigation.loadURI(uri,
		       Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
		       null, null, null);
	}
    } catch (e) {
	moz2ch.debug("moz2ch.sureView.loadURI(" + uri + "):\n " + e);
    }
}; 

//ݥåץå״طδؿ
moz2chSureView.prototype.resPopup =
function (resNo) {
    try{
		var html = this.data.getRes(resNo-1);
		if(html == "") return;

		var tooltiptext = html;

		var observer = {
		    tip: null,
	    	wait: function() {
				var obs = this;
				function delayObserve() {
		    		obs.observe();
				};
				pop_timer = setTimeout(delayObserve, 50);
	    	},
	    	observe: function() {		
				if(!this.tip) {
		    		this.tip = '<table border="0" cellspacing="0" cellpadding="0" style="font-size:smaller; color:#000000"><tr><td>' + tooltiptext + '</td></tr></table>';
		    		this.wait();
				} else {
		    		moz2ch.sureView.addPopup(this.tip ,0);
				}
	    	}
		};	    
		observer.wait();
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.mailPopup =
function (mailLink) {
    try{
	var observer = {
	    tip: null,
	    wait: function() {
		var obs = this;
		function delayObserve() {
		    obs.observe();
		};
		mail_timer = setTimeout(delayObserve, 50);
	    },
	    observe: function() {	
		if(!this.tip) {
		    this.tip = '<span style="font-size:' + "smaller" + '; color:' + "#000000" + '">' + mailLink + '</span>';
		    this.wait();
		} else {
		    moz2ch.sureView.addPopup(this.tip ,0);
		}
	    }
	};
	observer.wait();
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.imgPopup =
function (imgLink) {
    try{
	imgObserver = {
	    popImage: null,
	    wait: function() {
		var obs = this;
		function delayObserve() {
		    obs.observe();
		};
		img_timer = setTimeout(delayObserve, 100);
	    },
	    observe: function() {		
		if(this.popImage.complete != true) {
		    this.wait();
		} else {
		    var imgWidth = this.popImage.width;
		    var imgHeight = this.popImage.height;
    
		    if(imgWidth > (content.innerWidth*0.4)){
			var w_fix = imgWidth / (content.innerWidth*0.4);
			imgWidth = imgWidth / w_fix;
			imgHeight = imgHeight / w_fix;
		    }
		    if(imgHeight > (content.innerHeight*0.4)){
			var h_fix = imgHeight / (content.innerHeight*0.4);
			imgWidth = imgWidth / h_fix;
			imgHeight = imgHeight / h_fix;
		    }

		    moz2ch.setBusy(false);
		    moz2ch.sureView.addPopup('<img width="' + imgWidth + '" height="' + imgHeight + '">' ,this.popImage);
		}
	    }
	};

	moz2ch.setBusy(true);
	imgObserver.popImage = new Image();
	imgObserver.popImage.src = imgLink;
	if(this.element.contentDocument.images.length > 0){
	    for(var i=0; i<(this.element.contentDocument.images.length - 1); i++){
		if(this.element.contentDocument.images[i].src == imgObserver.popImage.src){
		    moz2ch.setBusy(false);
		    return;
		}
	    }
	}
	imgObserver.wait();

    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.addPopup =
function(tip, imgObj){
    try{
    var observer = {
	wait: function() {
	    var obs = this;
	    function delayObserve() {
		obs.observe();
	    };
	    disp_timer = setTimeout(delayObserve, 50);
	},
	observe: function() {		
	    moz2ch.sureView.makeVisible( maxid - 1 );
	}
    };

	if(img_timer) clearTimeout(img_timer);
	if(pop_timer) clearTimeout(pop_timer);
	if(mail_timer) clearTimeout(mail_timer);

    var bodynode = this.element.contentDocument.getElementsByTagName("body")[0];
    if(bodynode.lastChild){
	popupId.push(maxid);
	maxid = maxid + 1;

	var range = this.element.contentDocument.createRange();
	range.selectNodeContents(bodynode);
	range.collapse(true);

	var cf = range.createContextualFragment('<div>' + tip + '</div>');
	cf.firstChild.id = "Popup" + (maxid-1);
	
	var popstyle = cf.firstChild.style;

	popstyle.color = "#000000";
	popstyle.backgroundColor = this.popupColor;
	popstyle.borderColor = "#000080";
	popstyle.borderWidth = "1px";
	popstyle.padding = "4px";
	popstyle.borderStyle = "ridge";
	popstyle.position = "absolute";
	popstyle.visibility = "hidden";
	popstyle.left = "0px";
	popstyle.top = "0px";

	//ɸꤹappend()
	bodynode.appendChild(cf);

	var poptip = this.element.contentDocument.getElementById("Popup" +(maxid-1));

	popstyle = poptip.style;
	//popstyle.visibility="hidden";

	var tpWd = poptip.offsetWidth;
	var tpHt = poptip.offsetHeight;
	var winWd = content.innerWidth-10+content.pageXOffset;
	var winHt = content.innerHeight-10+content.pageYOffset;
	var mousex = this.mousex;
	var mousey = this.mousey;
	var over_flag = 0;

	if(tpWd > (content.innerWidth*0.85)){
	    popstyle.width = content.innerWidth*0.85;
	    tpWd = poptip.offsetWidth;
	    tpHt = poptip.offsetHeight;
	}
	if((mousex+tpWd) > (winWd-20)){
	    popstyle.left = (winWd-20) - tpWd + "px";
	    over_flag = 1;
	}else{
	    popstyle.left = mousex + "px";
	}
	if((mousey+tpHt+10) > (winHt-10)){
	    popstyle.top = (winHt-20)-tpHt + "px";
	    if((((winHt-20)-tpHt) < mousey) && ((winHt-20) > mousey)){
		if(over_flag == 1){
		    if((mousey - 10 - tpHt) > content.pageYOffset){
			popstyle.top = mousey - 10 - tpHt + "px";
		    }
		}
	    }
	}
	else popstyle.top = mousey + "px";

	if(poptip.firstChild.nodeName == "IMG"){
	    this.element.contentDocument.images[0].src = imgObj.src;
	    if((imgObj.width + imgObj.height) == 0)
		moz2ch.status(moz2ch.getString("imgLoadError"));
	}
	this.load_flag = 1;

	observer.wait();
    }
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.makeVisible =
function( target ){
	if(disp_timer) clearTimeout(disp_timer);

    var poptip = this.element.contentDocument.getElementById("Popup" + target);
    poptip.style.visibility = "visible";
    this.presentPopup = 1;
};

moz2chSureView.prototype.shouldPresentPopup =
function(){
	if(!this.checkRootDiv()){
	    this.removePopup(-1);
		return;
	}

	if(maxid > (parseInt(this.onmouseTargetId.split("Popup")[1]) + 1))
	    this.removePopup( parseInt(this.onmouseTargetId.split("Popup")[1]) + 1)
};

moz2chSureView.prototype.checkRootDiv =
function (){
	var targetNode = this.onmouseNode;
	while(targetNode.parentNode){
		if(targetNode.id){
			this.onmouseTargetId = targetNode.id;
			return true;
		}
		targetNode = targetNode.parentNode
	}
	return false;
};

moz2chSureView.prototype.removePopup =
function( targetNum ){
    try{
	var bodynode = this.element.contentDocument.getElementsByTagName("body")[0];
	if(!bodynode) return;

	var divnode = new Array();
	if(bodynode.lastChild){
	    divnode = this.element.contentDocument.getElementsByTagName("div");
	    if(!divnode){
		return;
	    }
	}else{
	    return;
	}

	var i;
	var ids;

	for(i=(divnode.length-1); i>=0; i--){
	    if(!divnode[i].getAttributeNode("id")) continue;
	    if(targetNum == -1){
		if(divnode[i].getAttributeNode("id").nodeValue.match("Popup")){
		    bodynode.removeChild(divnode[i]);
		}
	    }else{
		ids = parseInt(divnode[i].getAttributeNode("id").nodeValue.split("Popup")[1]);
		if(ids >= targetNum){
		    bodynode.removeChild(divnode[i]);
		}
	    }
	}
	if(targetNum == -1 || targetNum == 0){
	    this.presentPopup = 0;
	    maxid = 0;
	    popupId = null;
	    popupId = new Array();
	}
    }catch(e){ moz2ch.debug(e); }

    moz2ch.setBusy(false);
}; 

//ݥطδؿ
moz2chSureView.prototype.getCurScrollPos = 
function() {
    try{
	var scroll = (this.element.webNavigation).QueryInterface(Components.interfaces.nsIScrollable);
    return scroll.getCurScrollPos (scroll.ScrollOrientation_Y);
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.setCurScrollPos = 
function( pos ) {
    try{
	if(pos_timer) clearTimeout(pos_timer);
	var scroll = (this.element.webNavigation).QueryInterface(Components.interfaces.nsIScrollable);
	scroll.setCurScrollPosEx (0, parseInt(pos));
    }catch(e){ moz2ch.debug(e); }
};

//٥ȥϥɥδؿ
moz2chSureView.prototype.onLocationChange = 
function( webPrg, req, uri) {
    if(img_timer) clearTimeout(img_timer);
    if(pop_timer) clearTimeout(pop_timer);
    if(mail_timer) clearTimeout(mail_timer);
    if(disp_timer) clearTimeout(disp_timer);
    if(pos_timer) clearTimeout(pos_timer);
    this.load_flag = 0;
};

moz2chSureView.prototype.onStateChange =
function( webPrg, req, state, f) {
try{
	if(state == 786448){
	    var observer = {
	        wait: function() {
			var obs = this;
			function delayObserve() {
		    	obs.observe();
			};
			pos_timer = setTimeout(delayObserve, 50);
	    	},
	    	observe: function() {
			clearTimeout(pos_timer);
			moz2ch.sureView.setCurScrollPos( moz2ch.sureView.data.ita.getAttribute( moz2ch.sureView.data.sureId, "surePos"));
			if (moz2ch.sureView.data.ita.getAttribute( moz2ch.sureView.data.sureId, "surePos") != moz2ch.sureView.getCurScrollPos())
				obs.wait();
	    	}
		};
	    if(this.data){
		if(moz2ch.checkStatusDefault() == moz2ch.getString("endparse")){
		    moz2ch.status();
		    moz2ch.defaultStatus(moz2ch.getString("defaultStatus"));
		}
		var pos = this.data.ita.getAttribute( this.data.sureId, "surePos");
		var pos_n = this.getCurScrollPos();
		if(this.load_flag == 0 && pos_n != pos){
		    observer.wait();
		}
	    }
	}
    }catch(e){ alert(e); }
};

moz2chSureView.prototype.onProgressChange = 
function( webPrg, req, curSelfPrg, maxSelfPrg, curTotalPrg, maxTotalPrg ) {
};

moz2chSureView.prototype.onSecurityChange = 
function( webPrg, req, state) {
};

//2ch󥯤ν
moz2chSureView.prototype.open2chLinkWithTab =
function( url, title ) {
    try{
	this.load_flag = 0;

	var array = url.split("/");
	var sabaurl = array.slice(0,3).join("/") + "/" + array[5] + "/";

	if(sabaurl.match("baniisan.s12.xrea.com"))
	sabaurl = "http://baniisan.s12.xrea.com/x/moz2ch/";

	var sabaType;
	if(sabaurl.match("jbbs.livedoor.jp")){
		sabaType = "jbbs";
		sabaurl = sabaurl + array[6] + "/";
	}
	else if (sabaurl.match("www.machi.to"))
		sabaType = "machi";
	else
		sabaType = "2ch";

	var itaname = moz2ch.itaTreeView.data.urltoTitle(sabaurl);
	var ita;
	if(itaname == "non match"){
	    ita = moz2ch.bbsManager.createIta(sabaType, moz2ch.itaTreeView.data, moz2ch.getString("untitled"), sabaurl);
    }else{
		var l = moz2ch.itaView.element.mTabContainer.childNodes.length;
		var ita_check = 0;
   		for(var i=0; i<l; i++){
       		if(moz2ch.itaView.element.mTabContainer.childNodes[i].ita){
           		if(moz2ch.itaView.element.mTabContainer.childNodes[i].ita.url == sabaurl){
               		ita_check = i+1
           		}
       		}
   		}
		if(ita_check > 0){
           	ita = moz2ch.itaView.element.mTabContainer.childNodes[ita_check-1].ita;
		}else{
        	ita_check = 0;
			l = this.element.mTabContainer.childNodes.length;

    		for(var i=0; i<l; i++){
        		if(this.element.mTabContainer.childNodes[i].sure.ita){
            		if(this.element.mTabContainer.childNodes[i].sure.ita.url == sabaurl){
                		ita_check = i+1;
            		}
        		}
    		}
    		if(ita_check > 0){
            	ita = this.element.mTabContainer.childNodes[ita_check-1].sure.ita;
				if(ita.url == moz2ch.itaView.data.url){
                	moz2ch.itaView.load(ita);
                	moz2ch.itaView.element.mCurrentTree.treeBoxObject.invalidate();
                	//moz2ch.itaView.element.mCurrentTree.treeBoxObject.view = moz2ch.itaView;
            	}
	    	}else{
	        	ita = moz2ch.bbsManager.createIta(sabaType, moz2ch.itaTreeView.data, itaname, sabaurl);
            	if(ita.url != moz2ch.itaView.data.url){
	        		ita.readLog();
	            	ita.reload();
            	}else{
                	ita.addDataLoadedListener( moz2ch.itaView );
                	moz2ch.itaView.load(ita);
                	moz2ch.itaView.element.mCurrentTree.treeBoxObject.invalidate();
            	}
        	}
		}
	}

	if(!title)
	var sure = moz2ch.bbsManager.createSure(sabaType, ita, moz2ch.getString("untitled"), url);
	else
	var sure = moz2ch.bbsManager.createSure(sabaType, ita, title , url);
	var tab = this.tabFor( sure );
	if ( ! tab ){
	    tab = this.element.addTab("about:blank");
	    try{
		this.element.selectedTab = tab;
	    }catch(e){ 
	    moz2ch.debug(e); 
	    }
	}else{
	    try{
		this.element.selectedTab = tab;
	    }catch(e){
		moz2ch.debug(e);
	    }
	    this.reload();
	    return;
	}
	sure.addDataLoadedListener( this );
	this.load(sure);
	this.reload();
	
    }catch(e){ moz2ch.debug(e); }
};

moz2chSureView.prototype.tabFor = 
function ( sure ) {
    var tc = this.element.mTabContainer.childNodes;
    for( var i=0; i<tc.length; i++ ) {
        if ( tc[i].sure ) {
            if ( sure.url == tc[i].sure.url )
                return tc[i];
        }
    }
};

//
moz2chSureView.prototype.find = 
function () {
    try{
        var findInstData = new nsFindInstData();
        findInstData.browser = this.element;
        findInPage(findInstData);
    }catch(e){
        moz2ch.debug(e);
    }
};

moz2chSureView.prototype.findAgain = 
function (reverse) {
    try{
	if(document.getElementById("find-field").value){
	    if(reverse == false)
	    moz2chResFindNext();
	    else
	    moz2chResFindPrevious();
	    return;
	}
        var findInstData = new nsFindInstData();
        findInstData.browser = this.element;
        findAgainInPage(findInstData, reverse);
    }catch(e){
        moz2ch.debug(e);
    }
};

moz2chSureView.prototype.openLocalDat =
function ( fileURL ) {
    try{
	this.load_flag = 0;
	
	sabaurl = "http://baniisan.s12.xrea.com/x/moz2ch/";
	
	var ita;
	ita = moz2ch.bbsManager.createIta("2ch", moz2ch.itaTreeView.data, moz2ch.getString("untitled"), sabaurl);
	
	var sure = moz2ch.bbsManager.createSure("2ch", ita, moz2ch.getString("untitled"), fileURL);

	sure.addDataLoadedListener( this );
	var tab = this.element.addTab("about:blank", null);
	try{
	    this.element.selectedTab = tab;
	}catch(e){ 
	    moz2ch.debug(e); 
	}
	this.targetBrowser = this.element.mCurrentBrowser;
	this.data = sure;
	var fname;
	if(navigator.platform.match("Win")){
	    fname = fileURL.replace("file:///","");
	    fname = fname.replace(/\//g,"\\");
	    fname = fname.replace(/%20/g, " ");
	}else{
	    fname = fileURL.replace("file://", "");
	}
	this.data.loadLocalDat(fname);
    }catch(e){ moz2ch.debug(e); }
};

/////////////////////////////
// Implements DataLoadedListener
moz2chSureView.prototype.onDataLoaded = 
function ( eventObject ) {
	var targetBrowser = this.element.getBrowserForTab(this.tabFor(eventObject.data));
	if (targetBrowser == null)
		targetBrowser = this.element.getBrowserForTab(this.element.selectedTab);
	if(this.targetBrowser == targetBrowser){
    moz2ch.itaView.element.mCurrentTree.treeBoxObject.invalidate();
    if(this.data.ita.getAttribute(this.data.datID + ".dat", "sureNew") > 0){
	this.data.ita.writeIndex();
    }
	}else {
	}
	if(targetBrowser.currentURI && targetBrowser.currentURI.spec == eventObject.url){
	targetBrowser.reload(Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE);
	}else{
    targetBrowser.loadURIWithFlags( eventObject.url,
		       Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,
		       null, null, null );
	}
};

//Хؿ
function moz2chSureReload() {
    moz2ch.sureView.load_flag = 0;
    moz2ch.sureView.removePopup();

    try{
	if(moz2ch.sureView.data)
	    moz2ch.itaView.saveCurSurePos();
        moz2ch.sureView.reload();
    }catch(e){
        moz2ch.debug(e);
    }
}

function moz2chSureLogDelete() {
    moz2ch.sureView.logDelete();
    moz2ch.sureView.data.clearSureAttribute();
}

function moz2chSureReGet() {
    if(moz2ch.sureView.data){
	moz2ch.sureView.logDelete();
	moz2ch.sureView.data.clearSureAttribute();
	moz2ch.sureView.reGet();
    }
}

function moz2chSureClick( event ) {
    moz2ch.setCurrent(moz2ch.sureView);

    try{
    var browser;
    
    var target = event.target;
    var linkNode = null;
    var local_name = target.localName;

    if (local_name) {
        local_name = local_name.toLowerCase();
    }

    switch (local_name) {
    case "a":
    case "area":
    case "link":
        if (target.hasAttribute("href")) 
            linkNode = target;
        break;
    case "input":
        if ((event.target.type == "text") // text field
              && !isKeyPress       // not a key event
              && event.detail == 2 // double click
              && event.button == 0 // left mouse button
              && event.target.value.length == 0) { // no text has been entered
            prefillTextBox(target); // prefill the empty text field if possible
        }
        break;
    default:
	linkNode = event.originalTarget;
	while (linkNode && !(linkNode instanceof HTMLAnchorElement))
	    linkNode = linkNode.parentNode;
        // <a> cannot be nested.  So if we find an anchor without an
        // href, there is no useful <a> around the target
        if (linkNode && !linkNode.hasAttribute("href"))
            linkNode = null;
        break;
    }

    var href;
    if (linkNode) {
        href = linkNode.href;
    } else {
        // Try simple XLink
        linkNode = target;
        while (linkNode) {
            if (linkNode.nodeType == Node.ELEMENT_NODE) {
                href = linkNode.getAttributeNS("http://www.w3.org/1999/xlink", "href");
                break;
            }
            linkNode = linkNode.parentNode;
        }
        if (href && href != "") {
            href = makeURLAbsolute(target.baseURI,href);
        }
    }

    if(moz2chSureIsResInfo( href )){
        document.getElementById('content').loadURI( href );
		event.stopPropagation();
	return false;
    } else if(moz2chSureIsKakikoInfo( href )){
        moz2chSureKakiko( href.split("#kakiko")[1] );
		event.stopPropagation();
		return false;
	} else if(moz2chSureIsIdInfo( href )){
        moz2chSureIdAbone( href.split("#idabone_")[1] );
		event.stopPropagation();
		return false;
    } else if((moz2chSureIsPathInfo( href ) || moz2chSureIsKey( href ) )&& event.button == 0) {
	moz2ch.itaView.saveCurSurePos();
	moz2ch.sureView.open2chLinkWithTab( href, null );
	event.stopPropagation();
        return false;
    } else if(linkNode && href && event.button == 0){
	moz2ch.sureView.removePopup();
	var link = { 
	    href : linkNode.getAttribute("URL"),
	    getAttribute : function(attr) {
		if(attr == "title"){
		    return linkNode.firstChild.firstChild.getAttribute("label");
		}else{
		    return "";
		}
	    }
	};
	var windows = winm.getMostRecentWindow('navigator:browser');
	if(windows && moz2ch.sureView.tabLink == true){
		windows.focus();

	    windows.getBrowser().loadTabs(href.split("|"), false, false);
	}else{
	    openNewWindowWith(href, link, false); 
	}
	event.stopPropagation();
        return false;
    }else{
	moz2ch.sureView.removePopup();
	return true;
    }
    
    }catch(e) {
        moz2ch.debug(e);
    }

    return false;
}

function moz2chSureKakiko( num ) {
    try{
	if (!num) num = 0;
        if ( ! moz2ch.sureView.data.kakikoView ) {
            moz2ch.sureView.data.kakikoView = window.openDialog("kakiko.xul", "_blank" , "chrome,all,dialog=no,dependent=yes" , moz2ch.sureView.data, 0 /* KAKIKO mode */, num);
        }
    }catch(e){
        moz2ch.debug("Error! moz2chSureKakiko: " + e + "\n");
    }
}

function moz2chSureIdAbone( str ) {
    try{
	if (!str) return;
	moz2chAbone.add( "Id", str );
    }catch(e){
        moz2ch.debug("Error! moz2chSureKakiko: " + e + "\n");
    }
}

function moz2chSureMousePos(evt){
    moz2ch.sureView.mousex = evt.pageX;
    moz2ch.sureView.mousey = evt.pageY;
    moz2ch.sureView.onmouseNode   = evt.target;

    if(moz2ch.sureView.presentPopup == 1)
	moz2ch.sureView.shouldPresentPopup();
}

function moz2chSureRemovePopupTimer(){
    if(img_timer) clearTimeout(img_timer);
    if(pop_timer) clearTimeout(pop_timer);
    if(mail_timer) clearTimeout(mail_timer);
    if(disp_timer) clearTimeout(disp_timer);
    moz2ch.setBusy(false);
}

function moz2chResFind(aValue){
	try{
    var val = aValue || moz2ch.findBar._findField.value
   
    moz2ch.findBar._setHighlightTimeout();
    
    var fastFind = moz2ch.findBar.browser.fastFind;

	var res = fastFind.find(val, moz2ch.findBar._findMode == moz2ch.findBar.FIND_LINKS);
	moz2ch.findBar._updateFoundLink(res);
	}catch(e){ }
}

function moz2chResFindNext()
{
    var fastFind = moz2ch.findBar.browser.fastFind;
    var res = fastFind.findAgain(false, moz2ch.findBar._findMode == moz2ch.findBar.FIND_LINKS);

    moz2ch.findBar._updateFoundLink(res);
}

function moz2chResFindPrevious()
{
    var fastFind = moz2ch.findBar.browser.fastFind;
    var res = fastFind.findAgain(true, moz2ch.findBar._findMode == moz2ch.findBar.FIND_LINKS);

    moz2ch.findBar._updateFoundLink(res);
}

function moz2chSureOsusume()
{
    try{
	if(!moz2ch.sureView.data){ alert("No sure Loaded!"); return; }
        if(moz2ch.sureView.data.bbsId != "2ch"){ alert("Osusume is supported only 2ch!"); return; }
        if(!moz2ch.osusume)
            moz2ch.osusume = window.openDialog("osusume.xul", "_blank" , "chrome,all,dialog=no,dependent=yes");
    }catch(e){
	moz2ch.debug(e);
    }
}

function moz2chSureKanren()
{
    try{
	if(!moz2ch.sureView.data){ alert("No sure Loaded!"); return; }
        if(moz2ch.sureView.data.bbsId != "2ch"){ alert("Kanren is supported only 2ch!"); return; }
        if(!moz2ch.kanren)
            moz2ch.kanern = window.openDialog("kanren.xul", "_blank" , "chrome,all,dialog=no,dependent=yes");
    }catch(e){
	moz2ch.debug(e);
    }
}
function moz2chSureLoadSearch(target)
{
    var ss = Cc["@mozilla.org/browser/search-service;1"].
             getService(Ci.nsIBrowserSearchService);
    var engine;
  
    engine = ss.currentEngine;

    var submission = engine.getSubmission(target, null); // HTML response

    if (!submission)
      return;

	var windows = winm.getMostRecentWindow('navigator:browser');
	if(windows){

	windows.focus();
    var tab = windows.getBrowser().loadOneTab(submission.uri.spec, null, null,
                              submission.postData, null, false);
    windows.getBrowser().selectedTab = tab;
	}else{
		openNewWindowWith(submission.uri.spec, null, submission.postData);
	}
}

var reg_rinfo = new RegExp().compile("file:\/\/\/.+\/Moz2ch\/moz2ch_[0-9]+\.html#[0-9]+");
var reg_kinfo = new RegExp().compile("file:\/\/\/.+\/Moz2ch\/moz2ch_[0-9]+\.html#kakiko[0-9]+");
var reg_idinfo = new RegExp().compile("file:\/\/\/.+\/Moz2ch\/moz2ch_[0-9]+\.html#idabone_[a-zA-Z0-9/+.]+");
var reg_localinfo = new RegExp().compile("file:\/\/\/.+\/[0-9]+\.dat");
var reg_pinfo = new RegExp().compile("http:\/\/.+\/test\/read\.cgi\/[0-9A-Za-z]+\/[0-9]+");
var reg_pinfojbbs = new RegExp().compile("http:\/\/jbbs\.livedoor\.jp\/.+\/[0-9]+\/[0-9]+");
var reg_key = new RegExp().compile("http:\/\/.+\/test\/read\.cgi.bbs=[0-9A-Za-z]+&key=[0-9]+");

moz2chSureIsResInfo = 
function( url ) {
    return reg_rinfo.test( url );
};

moz2chSureIsKakikoInfo = 
function( url ) {
    return reg_kinfo.test( url );
};

moz2chSureIsIdInfo = 
function( url ) {
    return reg_idinfo.test( url );
};

moz2chSureIsLocalInfo = 
function( url ) {
    return reg_localinfo.test( url );
};

moz2chSureIsPathInfo = 
function( url ) {
    if(url.match("&u=d:")) return false
	var ret = reg_pinfo.test( url ) | reg_pinfojbbs.test( url );
    return ret; //reg_pinfo.test( url );
};

moz2chSureIsKey = 
function( url ) {
    return reg_key.test( url );
};

